####yamapan.tokyo
# Name directory
$static_logName = "CheckNWResult"

#Get Script Located Path
$logDirPath = $PSScriptRoot

# Set log location and filename
$logFilePath = "${logDirPath}\${static_logname}_$($(Get-Date).ToString("yyyyMMdd_HHmmss")).log"

###Target URL setting
$URLs=@()
$URLs+= "yahoo.co.jp"
$URLs+= "abehiroshi.la.coocan.jp"
$URLs+= "google.com"


#Start Transcript
Start-Transcript -path "${logFilePath}" -Append
Write-Output "-----ScriptStart----- $(Get-Date)"


###################################
#getInfos
function getInfos {
    Write-Output ""
    Write-Output "----------"
    Write-Output "#####getInfo######"
    Write-Output "###hostname"
    $hostname=HOSTNAME.EXE
    $hostname
    Write-Output "###ipconfig"
    $ipconfig=ipconfig.exe
    $ipconfig
    Write-Output "----------"
    Write-Output ""
}

##tnc func
function Check_connect443 ($Test_URLs){
    Write-Output "#TRY!! Test-NetConnection $Test_URLs  port 443 "
         
        $PortNo= "443"
        $resulttnc=tnc $Test_URLs -Port $PortNo
        $resultComputername=$resulttnc.computername
        $resultRemoteaddress=$resulttnc.remoteaddress.IPAddressToString
        $resultTcpTestSucceeded=$resulttnc.TcpTestSucceeded
        $resultSourceIP=$resulttnc.SourceAddress.IPAddress
        Write-Output "Result of tnc - $portNo / from $resultSourceIP /To URL  $resultComputername IPaddress $resultRemoteaddress / TcpTestSucceeded: $resultTcpTestSucceeded "
        Start-Sleep -Seconds 1
  }

  
function Check_connect80 ($Test_URLs){
    Write-Output "#TRY!! Test-NetConnection $Test_URLs  port 80 "

        $PortNo= "80"
        $resulttnc=tnc $Test_URLs -Port $PortNo
        $resultComputername=$resulttnc.computername
        $resultRemoteaddress=$resulttnc.remoteaddress.IPAddressToString
        $resultTcpTestSucceeded=$resulttnc.TcpTestSucceeded
        $resultSourceIP=$resulttnc.SourceAddress.IPAddress
        Write-Output "Result of tnc - $portNo / from $resultSourceIP /To URL  $resultComputername IPaddress $resultRemoteaddress / TcpTestSucceeded: $resultTcpTestSucceeded "
        Start-Sleep -Seconds 1
  }


  function Check_curl($Test_URLs) {
    Write-Output "#TRY!! Invoke-webRequest $Test_URLs  "
    $Invoke=Invoke-webRequest $Test_URLs
    $InvokeStatusCode=$Invoke.StatusCode
    $InvokeStatusDescription=$Invoke.StatusDescription
    Write-Output "Result of Invoke-webRequest  / StatusCode: $InvokeStatusCode/ StatusDescription: $InvokeStatusDescription"
      
  }
#winhttp_proxyCheck
function http_proxy(){
    Write-Output ""
    Write-Output "--------------------------------------------"
    Write-Output "##Check WinHttpProxy"
    netsh winhttp show proxy
    Write-Output "--------------------------------------------"
}


#########################################################################################################
###GetInfos
getInfos;
###WInhttpProxy
http_proxy;

#######疎通確認
Write-Output ""
Write-Output "--------------------------------------------"
Write-Output "### Check connection to Yahoo! , abehiroshi ,google ### "
foreach ($URL in $URLs) {
    Write-Output "## Check connection to $URL ## "
	Check_connect443($URL)
    Check_connect80 ($URL)
    Check_curl($URL)
}




 


Write-Output "-----ScriptStart Completed----- $(Get-Date)"

##Complete Transcript
Stop-Transcript